clear all
close all
trans=@(q)  [2*q(1,:);q(2,:);0.5*q(3,:).*(1+0.5*sin(2*pi*q(1,:)))];
meshfile=gmsh.buildmesh3d('ball8',20);
Th=siMesh(meshfile,'trans',trans);
fprintf('Mesh : nq=%d, nme=%d, h=%.3f\n',Th.nq,Th.get_nme(),Th.get_h())

figure(1)
axis off;axis image
Th.plot('d',2,'legend',true);



u=@(x,y,z) cos(2*x-y-z).*sin(x-2*y+z);
U=Th.eval(u);
figure(2)
axis off;axis image;hold on
P=fc_tools.graphics.PlaneCoefs([0 0 0],[0 1 1]);
Th.slice(U,P)
Th.plotVal(U,'d',2,'labels',[1,2],'EdgeColor','None')
caxis([min(U),max(U)])
isorange=linspace(min(U),max(U),15);
Th.plot('d',2,'labels',[3,4],'FaceColor','none', 'EdgeColor',0.95*[1,1,1])
Th.plotIsolines(U,'labels',[3,4],'isorange',isorange,'color','w')
Th.isoslice(U,P,'isorange',isorange,'color','w')
shading interp
%Th.plot('d',2,'labels',[10,20,21], 'legend',false, 'PlotOptions',{'FaceAlpha',0.1,'FaceColor','none', 'EdgeColor',0.95*[1,1,1]})
view(127,-1)

figure(3)
axis off;axis image;hold on
P1=fc_tools.graphics.PlaneCoefs([0 0 0],[1 0 0]);
Th.slice(U,P1,'FaceColor','interp')
Th.isoslice(U,P1,'isorange',isorange,'color','w')
P2=fc_tools.graphics.PlaneCoefs([0 0 0],[0 1 0]);
Th.slice(U,P2,'FaceColor','interp')
Th.isoslice(U,P2,'isorange',isorange,'color','w')
P3=fc_tools.graphics.PlaneCoefs([0 0 0],[0 0 1]);
Th.slice(U,P3,'FaceColor','interp')
Th.isoslice(U,P3,'isorange',isorange,'color','w')
P4=fc_tools.graphics.PlaneCoefs([-1 0 0],[1 0 0]);
Th.slice(U,P4,'FaceColor','interp')
Th.isoslice(U,P4,'isorange',isorange,'color','w')
P5=fc_tools.graphics.PlaneCoefs([1 0 0],[1 0 0]);
Th.slice(U,P5,'FaceColor','interp')
Th.isoslice(U,P5,'isorange',isorange,'color','w')
view(-52,20)

%Th.plot('d',2,'labels',[10,20,21], 'legend',false, 'PlotOptions',{'FaceAlpha',0.1,'FaceColor','none', 'EdgeColor',0.95*[1,1,1]})

%Th.plotVal(U,'d',2,'labels',[10,20,21,100,101])
%Th.plotIsolines(U,'labels',[10,20,21,100,101],'isorange',isorange,'PlotOptions',{'Color','w'})
%Th.plotVal(U,'d',2,'labels',[100,101])
%Th.plotIsolines(U,'labels',[100,101],'isorange',isorange,'PlotOptions',{'Color','w'})
%caxis([min(U),max(U)])
%shading interp
Th.plot('d',1,'color','k','Linewidth',1.5)

figure(4)
axis off;axis image;hold on
P1=fc_tools.graphics.PlaneCoefs([0 0 0],[1 0 0]);
Th.slicemesh(P1,'FaceColor',0.9*[1 1 1],'EdgeColor','none')
Th.isoslice(U,P1,'isorange',isorange)
P2=fc_tools.graphics.PlaneCoefs([0 0 0],[0 1 0]);
Th.slicemesh(P2,'FaceColor',0.9*[1 1 1],'EdgeColor','none')
Th.isoslice(U,P2,'isorange',isorange)
P3=fc_tools.graphics.PlaneCoefs([0 0 0],[0 0 1]);
Th.slice(U,P3,'FaceColor','interp')
Th.isoslice(U,P3,'isorange',isorange,'color','w')
P4=fc_tools.graphics.PlaneCoefs([-1 0 0],[1 0 0]);
Th.slice(U,P4,'FaceColor','interp')
Th.isoslice(U,P4,'isorange',isorange,'color','w')
P5=fc_tools.graphics.PlaneCoefs([1 0 0],[1 0 0]);
Th.slice(U,P5,'FaceColor','interp')
Th.isoslice(U,P5,'isorange',isorange,'color','w')
Th.plot('d',1,'legend',false,'color','k','Linewidth',1.5)
view(-52,20)
