clear all
close all
meshfile=gmsh.buildmesh3d('cylinder3holes',30,'force',true,'check',true);
Th=ooMesh(meshfile)
u=@(x,y,z) cos(2*x-y-z).*sin(x-2*y+z);
U=Th.eval(u);
extern.fig(1)
axis off;axis image
P=PlanCoeff([0 0 1],[0 1 1]);
Th.slice(U,P)
Th.plotVal(U,'d',2,'labels',[100,101])
caxis([min(U),max(U)])
isorange=linspace(min(U),max(U),10);
Th.plot('d',2,'labels',[10,20,21], 'FaceColor','none', 'EdgeColor',0.95*[1,1,1])
Th.plotIsolines(U,'labels',[100,101],'isorange',isorange,'color','w')
Th.isoslice(U,P,'isorange',isorange,'color','w')
shading interp
%Th.plot('d',2,'labels',[10,20,21], 'legend',false, 'PlotOptions',{'FaceAlpha',0.1,'FaceColor','none', 'EdgeColor',0.95*[1,1,1]})
view(-114,11)
extern.fig(2)
axis off;axis image
P1=PlanCoeff([0 0 1],[1 0 0]);
Th.slice(U,P1)
Th.isoslice(U,P1,'isorange',isorange,'color','w')
P2=PlanCoeff([0 0 1],[0 1 0]);
Th.slice(U,P2)
Th.isoslice(U,P2,'isorange',isorange,'color','w')
P3=PlanCoeff([0 0 1],[0 0 1]);
Th.slice(U,P3)
Th.isoslice(U,P3,'isorange',isorange,'color','w')
Th.plot('d',2,'labels',[10,20,21], 'FaceColor','none', 'EdgeColor',0.95*[1,1,1])
%Th.plotVal(U,'d',2,'labels',[10,20,21,100,101])
%Th.plotIsolines(U,'labels',[10,20,21,100,101],'isorange',isorange,'PlotOptions',{'Color','w'})
Th.plotVal(U,'d',2,'labels',[100,101])
Th.plotIsolines(U,'labels',[100,101],'isorange',isorange,'color','w')
caxis([min(U),max(U)])
shading interp
Th.plot('d',1,'color','k','Linewidth',1.5)